function BlockMenu(sprite) {
    this.selType = 'text';
    this.sprite = sprite;
    this.listeners = [];
}

BlockMenu.prototype.fixCode = function (c, sprite, rerun) {
    let newCode = '';

    let lastLevel = 0;
    let lastCtrl = 0;
    let ignoreLevel = -1;
    let doNext = false;
    for (let i in c) {
        let e = c[i];
        if (ignoreLevel == e.level) {
            ignoreLevel = -1;
            continue;
        }

        let cmd = e.data; //.trim();
        if (cmd == '' && e.level > lastLevel) {
            ignoreLevel = e.level;
            continue;
        }
        let ln = '';
        if (commands[e.data] && commands[e.data].type == 'control') {
            ln = `\n${' '.repeat(Math.max(0, e.level - 1))}`;
            lastCtrl = e.level + 1;
        }
        if (doNext || (e.level <= lastCtrl)) {
            ln = `\n${' '.repeat(Math.max(0, e.level - 1))}`;
        }
        if (e.level == 0) {
            lastCtrl = 0;
        }
        doNext = (e.level <= lastCtrl);
        if (e.level > lastLevel) {
            newCode += `${ln}(${e.data}`;
            lastLevel = e.level;
        } else if (e.level < lastLevel) {
            newCode += `)${ln}${e.data}`;
            lastLevel = e.level;
        } else {
            newCode += `${e.data}`;
        }
    }

    if (!rerun) {
        this.fixCode(new Parser().parseBrace(newCode || ''), sprite, true);
        return;
    }

    sprite.code = newCode;


    let ta = document.querySelector('.left');
    ta.value = sprite.code || '';
    view.blocks(); // wow
}

BlockMenu.prototype.delTo = function (from, level, obj) {
    let c = new Parser().parseBrace(this.sprite.sprites[this.sprite.sel].code || '');

    let command = c[from].data.replaceAll(/\s+/g, '');
    let isComment = command == 'comment' || command == 'text';
    c.splice(from, 1 + isComment * 1, {
        level: level - 2,
        data: ''
    });

    this.fixCode(c, this.sprite.sprites[this.sprite.sel]);
}

BlockMenu.prototype.nukeTo = function (from, level, obj) {
    let c = new Parser().parseBrace(this.sprite.sprites[this.sprite.sel].code || '');

    let levelOrg = level;

    while (c[from].level >= levelOrg - 1) {
        c.splice(from, 1);
        from--;

        console.log(c[from].level)
    }

    this.fixCode(c, this.sprite.sprites[this.sprite.sel]);
}

BlockMenu.prototype.pushTo = function (from, level, obj, sel = false, sugg = false) {
    let c = new Parser().parseBrace(this.sprite.sprites[this.sprite.sel].code || '');

    let cmdData = commands[sel || this.selType] || {};

    c.splice(from + 1, 0, {
        data: sel || this.selType,
        level: level
    }, {
        data: '',
        level: level - 1
    });

    this.fixCode(c, this.sprite.sprites[this.sprite.sel]);

    if (!cmdData.argsTemplate) return;

    let template = !sugg ? cmdData.argsTemplate : templates[sugg];

    for (let i = template.length - 1; i >= 0; i--) {
        let ent = template[i];
        this.pushTo(from + 1, level + 1 + ent.depth, obj, ent.type, ent.sugg);
    }
}
BlockMenu.prototype.changeTo = function (from, level, obj) {
    let c = new Parser().parseBrace(this.sprite.sprites[this.sprite.sel].code || '');
    c[from].data = obj.querySelector('textarea').value.replaceAll('(', '\\(').replaceAll(')', '\\)').replaceAll('\\\\', '\\');

    this.fixCode(c, this.sprite.sprites[this.sprite.sel]);
}

BlockMenu.prototype.renderBlocks = function (data, from, level) {
    let command = data[from].data.replaceAll(/\s+/g, '');

    let div = document.createElement('div');

    let c = commands[command];

    div.textContent = c.alias || command;

    if (c && c.type) div.classList.add('block-' + c.type);
    if (level % 2 == 1 && level != 1) div.classList.add('odd_depth');

    let inn = div;
    if (command == 'text' || command == 'comment') {
        inn = document.createElement('textarea');
        inn.id = `textarea-${from}`
        div.appendChild(inn);
    }

    let args = 0;
    let argC = commands[command].args;
    if (argC == -1) argC = 1;

    let i = from + 1;
    for (i = from + 1; i < data.length; i++) {
        let entry = data[i];
        if (entry.level < level - 1) break;

        if (entry.level != level) continue;

        if (command == 'text' || command == 'comment') {
            inn.textContent += entry.data;
            continue;
        }

        if (entry.data == '') continue;

        let d = this.renderBlocks(data, i, level + 1);

        div.innerHTML += `<div class='button green' onclick='blocks.pushTo(${i - 1},${level},this)'>+</div>`
        div.appendChild(d);
        args++;

        //if (args == argC) break;
    }

    div.id = `div-${from}`;

    if (command == 'text' || command == 'comment') {
        div.innerHTML += `<div class='button red' onclick='blocks.delTo(${from},${level + 1},this)'>-</div>`
    } else {
        div.innerHTML += `<div class='button green' onclick='blocks.pushTo(${i - 1},${level},this)'>+</div>`
        div.innerHTML += `<div class='button red' onclick='blocks.delTo(${from},${level},this)'>-</div>`
        div.innerHTML += `<div class='button nuke' onclick='blocks.nukeTo(${i - 1},${level},this)'>X</div>`

        if (commands[command].args != -1 && args >= argC) {
            for (let g of div.querySelectorAll(`#div-${from} > .green`)) g.remove();
        }
    }


    let that = this;
    this.listeners.push(function (e) {
        if (e.target.id != `textarea-${from}`) {
            return;
        }
        for (let listener of that.listeners) {
            document.removeEventListener("change", listener);
        }
        that.listeners = [];
        blocks.changeTo(from + 1, level + 1, document.querySelector(`#div-${from}`));
    })

    document.addEventListener('change', this.listeners[this.listeners.length - 1]);

    return div;
}

BlockMenu.prototype.reselect = function (type) {
    for (let click of document.querySelectorAll('.clicker')) {
        click.style.display = 'none';
    }
    let displayed = [
        ...document.querySelectorAll('.typer'),
        ...document.querySelectorAll('.tooltip'),
        ...document.querySelectorAll('.block-' + type)
    ];
    for (let click of displayed) {
        click.style.display = '';
    }
}