function Parser() {
    this.variables = {};
}

Parser.prototype.parseBrace = function (str) {
    let out = [{
        "level": 0,
        "data": ""
    }];

    let level = 0;
    for (let j in str) {
        let i = str[j];
        if (((i != '(' && i != ')') || (j > 0 && str[j-1] == '\\')) && i) {
            out[out.length - 1].data += i;
            continue;
        }
        level += (i == '(') ? 1 : 0;
        level -= (i == ')') ? 1 : 0;
        level = Math.max(level,0);
        out.push({
            level,
            "data": ""
        });
    }

    let strLevel = Infinity;
    for (let i in out) {
        if (out[i].level > strLevel) {
            continue;
        } else {
            strLevel = Infinity;
        }
        out[i].data = out[i].data.replaceAll(/\s+/gm, " ").trim();
        if (out[i].data == 'text') strLevel = out[i].level;
    }


    return out;
}

Parser.prototype.parseCode = async function (data, from, level) {
    let result = false;
    let command = data[from].data;

    let args = [];

    for (let i = from + 1; i < data.length; i++) {
        if (this.stop) {
            return false;
        }

        let entry = data[i];
        if (entry.level < level - 1) break;

        if (command == 'text') {
            result = result || "";
            result += entry.data.replaceAll('\\','');
            continue;
        }

        if (entry.level != level) continue;

        let ij = Object.keys(commands).indexOf(command);
        let argC = (ij != -1) ? commands[command].args : -1;

        if (ij != -1 && commands[command].control && args.length ==  argC - 1 && entry.data != '') {
            return await commands[command].func(this,args,data,i,level+1);
        } else {
            if (entry.data == '') continue;
            let c = await this.parseCode(data, i, level + 1);
            if (c && c.ignore) continue;
            args.push(c);
            if (ij == -1) continue;
        }

        if (!commands[command].control && args.length == argC) {
            return await commands[command].func(this,args);
        }

    }

    if (!result && commands[command] && commands[command].func && (commands[command].args == 0 || commands[command].isArray)) {
        return await commands[command].func(this,args);
    }
    return result;
}