let templates = {
    'control': [
        { 'depth': 0, 'type': 'do' }
    ],
    'variableGet': [
        { 'depth': 0, 'type': 'size' }
    ],
    'variableSet': [
        { 'depth': 0, 'type': '150' }
    ],
    'variableInc': [
        { 'depth': 0, 'type': '15' }
    ],
    'eq': [
        { 'depth': 0, 'type': 'greater' },
        { 'depth': 0, 'type': 'less' }
    ],
    'jason': [
        { 'depth': 0, 'type': '{"data": "blah"}' }
    ],
    'wait': [
        { 'depth': 0, 'type': '1000' }
    ],
    'key': [
        { 'depth': 0, 'type': 'KeyA' }
    ],
    'web': [
        { 'depth': 0, 'type': 'https://google.com/' }
    ],
    'sprite': [
        { 'depth': 0, 'type': 'Starter2' }
    ],
    'sprite2': [
        { 'depth': 0, 'type': 'Starter' }
    ],
    'img': [
        { 'depth': 0, 'type': '0' } // https://home.zenoverse.net/raw/assets/2185e5ce-eab1-4a60-a91d-671aeb40c4dd'}
    ],
    'math': [
        { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' },
        { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
    ],
    'round': [
        { 'depth': 0, 'type': 'text', 'sugg': 'rounder' }
    ],
    'rounder': [
        { 'depth': 0, 'type': '15.26' }
    ],
    'audio': [
        { 'depth': '0', 'type': '1' } // 'https://home.zenoverse.net/raw/assets/c9c7d384-df8e-48a0-8892-fc4ef95a1813'}
    ],
    'compare': [
        { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' },
        { 'depth': 0, 'type': 'text', 'sugg': 'wait' }
    ]
};

let commands = {
    '': {
        'args': -1,
        'type': 'none'
    },
    'text': {
        'args': 0,
        'type': 'text',
        'argsTemplate': [
            { 'depth': 0, 'type': 'Type text or a number here' }
        ]
    },
    'do': {
        'args': -1,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'glide' }
        ]
    },
    'comment': {
        'args': 1,
        'type': 'comment',
        'argsTemplate': [
            { 'depth': 0, 'type': 'Annotate parts of your code for clarity, or describe what this project is for' }
        ]
    },
    'repeat': {
        'args': 2,
        'control': true,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' },
            { 'depth': 0, 'type': 'do' }
        ]
    },
    'summon': {
        'args': 1,
        'control': true,
        'type': 'control',
        'argsTemplate': templates.control,
        'alias': 'run without waiting'
    },
    'forever': {
        'args': 1,
        'control': true,
        'type': 'control',
        'argsTemplate': templates.control
    },
    'if': {
        'args': 2,
        'control': true,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'greater' },
            { 'depth': 0, 'type': 'do' }
        ]
    },
    'repeatUntil': {
        'args': 2,
        'control': true,
        'type': 'control',
        'alias': 'repeat while variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' },
            { 'depth': 0, 'type': 'do' }
        ]
    },
    'function': {
        'args': 1,
        'control': true,
        'type': 'control',
        'argsTemplate': templates.control
    },
    'message': {
        'args': 1,
        'control': true,
        'type': 'control',
        'argsTemplate': templates.control
    },
    'set': {
        'args': 2,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableSet' }
        ]
    },
    'get': {
        'args': 1,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' }
        ]
    },
    'increment': {
        'args': 2,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ]
    },
    'speak': {
        'args': 1,
        'type': 'output',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' }
        ]
    },
    'image': {
        'args': 1,
        'type': 'data',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'img' }
        ]
    },
    'add': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.math
    },
    'subtract': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.math
    },
    'multiply': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.math
    },
    'divide': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.math
    },
    'remainder': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.math
    },
    'floor': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'round down'
    },
    'join': {
        'args': 2,
        'type': 'string',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' },
            { 'depth': 0, 'type': 'text' }
        ]
    },
    'audio': {
        'args': 1,
        'type': 'data',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'audio' }
        ]
    },
    'play': {
        'args': 1,
        'type': 'output',
        'argsTemplate': [
            { 'depth': 0, 'type': 'audio' }
        ],
        'alias': 'play sound'
    },
    'wait': {
        'args': 1,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'wait' }
        ],
        'alias': 'wait milliseconds'
    },
    'call': {
        'args': 1,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'get' }
        ],
        'alias': 'call function'
    },
    'import': {
        'args': 2,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' }
        ],
        'alias': 'import variable from sprite'
    },
    'export': {
        'args': 3,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableGet' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableSet' }
        ],
        'alias': 'export variable to sprite'
    },
    'step': {
        'args': 1,
        'type': 'motion',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ],
        'alias': 'step in direction'
    },
    'glide': {
        'args': 3,
        'type': 'motion',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'wait' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ],
        'alias': 'glide over duration'
    },
    'look': {
        'args': 1,
        'type': 'motion',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' },
        ],
        'alias': 'look to'
    },
    'touching': {
        'args': 2,
        'type': 'motion',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' },
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite2' },
        ],
        'alias': 'are sprites touching'
    },
    'key': {
        'args': 1,
        'type': 'input',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'key' }
        ],
        'alias': 'key pressed'
    },
    'web': {
        'args': 1,
        'type': 'input',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'web' }
        ],
        'alias': 'fetch URL'
    },
    'random': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.compare,
        'alias': 'random number in range'
    },
    'greater': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.compare
    },
    'less': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.compare
    },
    'equal': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.compare
    },
    'and': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.eq
    },
    'or': {
        'args': 2,
        'type': 'logic',
        'argsTemplate': templates.eq
    },
    'not': {
        'args': 1,
        'type': 'logic',
        'argsTemplate': templates.eq
    },
    'index': {
        'args': 2,
        'type': 'variable',
        'argsTemplate': [
            { 'depth': 0, 'type': 'get' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ],
        'alias': 'array index'
    },
    'letters': {
        'args': 1,
        'type': 'string',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' }
        ],
        'alias': 'list of letters in'
    },
    'length': {
        'args': 1,
        'type': 'string',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' }
        ]
    },
    'where': {
        'args': 2,
        'type': 'string',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ],
        'alias': 'find in array'
    },
    'abs': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'absolute value'
    },
    'sqrt': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'square root'
    },
    'ceiling': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'round up'
    },
    'sin': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'cos': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'tan': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'asin': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'acos': {
        'args': 1,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'atan2': {
        'args': 2,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'angle from origin'
    },
    'log': {
        'args': 2,
        'type': 'math',
        'argsTemplate': templates.round,
        'alias': 'log with base'
    },
    'exponent': {
        'args': 2,
        'type': 'math',
        'argsTemplate': templates.round
    },
    'array': {
        'args': -1,
        'type': 'data',
        'isArray': 'true',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text' },
            { 'depth': 0, 'type': 'text' },
            { 'depth': 0, 'type': 'text' }
        ]
    },

    'at': {
        'args': 3,
        'type': 'motion',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite2' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' },
            { 'depth': 0, 'type': 'text', 'sugg': 'variableInc' }
        ]
    },
    'clickedHere': {
        'args': 1,
        'type': 'input',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite2' }
        ],
        'alias': 'sprite is clicked'
    },
    'clicked': {
        'args': 0,
        'type': 'input',
        'alias': 'mouse is clicked'
    },
    'timer': {
        'args': 0,
        'type': 'input'
    },
    'mouse': {
        'args': 0,
        'type': 'input',
        'alias': 'mouse coordinates'
    },
    'json': {
        'args': 1,
        'type': 'data',
        'argsTemplate': [
            { 'depth': 0, 'type': 'unjson' }
        ],
        'alias': 'to JSON'
    },
    'unjson': {
        'args': 1,
        'type': 'data',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'jason' }
        ],
        'alias': 'from JSON'
    },
    'clone': {
        'args': 2,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite2' },
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' }
        ],
        'alias': 'copy sprite'
    },
    'unclone': {
        'args': 1,
        'type': 'control',
        'argsTemplate': [
            { 'depth': 0, 'type': 'text', 'sugg': 'sprite' }
        ],
        'alias': 'remove sprite'
    }
}

commands.repeat.func = async function (obj, args, data, i, level) {
    for (let j = 0; j < args[0] * 1; j++) {
        await obj.parseCode(data, i, level);
        await sleep(1000 / 60);
    }
}

commands.forever.func = async function (obj, args, data, i, level) {
    while (true) {
        await obj.parseCode(data, i, level);
        await sleep(1000 / 60);
    }
}

commands.if.func = async function (obj, args, data, i, level) {
    if (args[0]) {
        await obj.parseCode(data, i, level);
    }
}

commands.repeatUntil.func = async function (obj, args, data, i, level) {
    while (true) {
        if (!(await commands.get.func(obj, args))) break;
        await obj.parseCode(data, i, level);
        await sleep(1000 / 60);
    }
}

commands.message.func = async function (obj, args, data, i, level) {
    return async function (object) {
        return await obj.parseCode(data, i, level);
    };
}

commands.function.func = async function (obj, args, data, i, level) {
    return async function (object) {
        return await object.parseCode(data, i, level);
    };
}

commands.wait.func = async function (obj, args) {
    await sleep(args[0]);
    return false;
}

commands.set.func = async function (obj, args) {
    if (args[0].type == 'index') {
        (args[0].from)[args[0].to] = args[1];
        return false;
    }
    obj.variables[args[0]] = args[1];
    if (args[0] == 'layer') sprite.resort();
    return false;
}

commands.get.func = async function (obj, args) {
    if (args[0].type == 'index') {
        return (args[0].from)[args[0].to]
    }
    return obj.variables[args[0]];
}

commands.increment.func = async function (obj, args) {
    obj.variables[args[0]] *= 1;
    obj.variables[args[0]] += args[1] * 1;
    return false;
}

commands.add.func = async function (obj, args) {
    return args[0] * 1 + args[1] * 1;
}

commands.subtract.func = async function (obj, args) {
    return args[0] * 1 - args[1] * 1;
}

commands.multiply.func = async function (obj, args) {
    return args[0] * args[1];
}

commands.divide.func = async function (obj, args) {
    return args[0] / args[1];
}

commands.remainder.func = async function (obj, args) {
    return args[0] % args[1];
}

commands.floor.func = async function (obj, args) {
    return Math.floor(args[0]);
}

commands.join.func = async function (obj, args) {
    return "" + args[0] + args[1];
}

commands.play.func = async function (obj, args) {
    await new Promise(function (resolve) {
        args[0].addEventListener('ended', function () {
            resolve()
        });
        args[0].play();
    })

    return false;
}

commands.image.func = async function (obj, args) {
    let img = new Image();
    img.crossOrigin = "anonymous";
    img.src = args[0];
    return img;
}

commands.audio.func = async function (obj, args) {
    let img = new Audio(args[0]);
    document.body.appendChild(img);

    return img;
}

commands.summon.func = async function (obj, args, data, i, level) {
    obj.parseCode(data, i, level);
    return false;
}

commands.do.func = async function (obj, args, data, i, level) {
    return await obj.parseCode(data, i, level);
}

commands.call.func = async function (obj, args, data, i, level) {
    return await args[0](obj);
}

commands.speak.func = async function (obj, args) {
    let locale = obj.variables.locale || 'en-US';
    let gender = obj.variables.gender || 'male';

    let params = new URLSearchParams({
        locale,
        gender,
        text: args[0]
    })

    await new Promise(function (resolve) {
        let dat = new Audio("https://synthesis-service.scratch.mit.edu/synth?" + params.toString());
        dat.addEventListener('ended', function () {
            resolve()
        });
        dat.play();
    })

    return false;
}

commands.import.func = async function (obj, args) {
    return sprite.sprites[args[0]].p.variables[args[1]];
}

commands.export.func = async function (obj, args) {
    sprite.sprites[args[0]].p.variables[args[1]] = args[2];
    return;
}

commands[''].func = commands['comment'].func = async function (obj, args) {
    return { ignore: true };
}

commands.step.func = async function (obj, args) {
    let dir = Math.PI / canvasHeight / 2 * (obj.variables["rotation"] - 90);
    obj.variables["x position"] += Math.cos(dir) * args[0];
    obj.variables["y position"] += Math.sin(dir) * args[0];
    return;
}

commands.glide.func = async function (obj, args, data, i, level) {
    let deltaX = args[1] - obj.variables['x position'];
    let deltaY = args[2] - obj.variables['y position'];
    for (let sec = 0; sec < 60 / 1000 * args[0]; sec++) {
        obj.variables['x position'] *= 1;
        obj.variables['y position'] *= 1;
        obj.variables['x position'] += deltaX * 1000 / 60 / args[0];
        obj.variables['y position'] += deltaY * 1000 / 60 / args[0];
        await sleep(1000 / 60);
    }
}

commands.look.func = async function (obj, args, data, i, level) {
    let pointer = sprite.sprites[args[0]].p;
    let deltaX = pointer.variables['x position'] - obj.variables['x position'];
    let deltaY = pointer.variables['y position'] - obj.variables['y position'];

    obj.variables['rotation'] = (-Math.atan2(deltaX, deltaY) * canvasHeight / 2 / Math.PI) + canvasHeight / 2;
    return;
}

commands.touching.func = async function (obj, args, data, i, level) {

    canvA.ctx.clearRect(0, 0, canvasWidth, canvasHeight);

    canvB.ctx.clearRect(0, 0, canvasWidth, canvasHeight);

    canvA.drawSprite(args[0]);
    canvB.drawSprite(args[1]);

    let caDat = canvA.ctx.getImageData(0, 0, canvasWidth, canvasHeight).data;
    let cbDat = canvB.ctx.getImageData(0, 0, canvasWidth, canvasHeight).data;

    for (let i = 3; i < caDat.length; i += 4) {
        if (caDat[i] > 0 && cbDat[i] > 0) return true;
    }

    return false;
}

commands.key.func = async function (obj, args, data, i, level) {
    return !!pressedKeys[args[0]];
}

commands.web.func = async function (obj, args, data, i, level) {
    return await (fetch(args[0]).then(x => x.text()));
}

commands.random.func = async function (obj, args, data, i, level) {
    return (Math.random() * (args[1] - args[0])) + args[0] * 1;
}

commands.greater.func = async function (obj, args, data, i, level) {
    return args[0] * 1 > args[1] * 1;
}

commands.less.func = async function (obj, args, data, i, level) {
    return args[0] * 1 < args[1] * 1;
}

commands.equal.func = async function (obj, args, data, i, level) {
    return args[0] == args[1];
}

commands.and.func = async function (obj, args, data, i, level) {
    return args[0] && args[1];
}

commands.or.func = async function (obj, args, data, i, level) {
    return args[0] || args[1];
}

commands.not.func = async function (obj, args, data, i, level) {
    return !args[0];
}

commands.index.func = async function (obj, args, data, i, level) {
    return {
        type: 'index',
        from: args[0],
        to: args[1]
    };
}

commands.letters.func = async function (obj, args, data, i, level) {
    return args[0].split('');
}

commands.length.func = async function (obj, args, data, i, level) {
    return args[0].length;
}

commands.where.func = async function (obj, args, data, i, level) {
    return args[0].indexOf(args[1]);
}
commands.abs.func = async function (obj, args, data, i, level) {
    return Math.abs(args[0]);
}
commands.sqrt.func = async function (obj, args, data, i, level) {
    return Math.sqrt(args[0]);
}
commands.ceiling.func = async function (obj, args, data, i, level) {
    return Math.ceil(args[0]);
}
commands.sin.func = async function (obj, args, data, i, level) {
    return Math.sin(args[0]);
}
commands.cos.func = async function (obj, args, data, i, level) {
    return Math.cos(args[0]);
}
commands.tan.func = async function (obj, args, data, i, level) {
    return Math.tan(args[0]);
}
commands.asin.func = async function (obj, args, data, i, level) {
    return Math.asin(args[0]);
}
commands.acos.func = async function (obj, args, data, i, level) {
    return Math.acos(args[0]);
}
commands.atan2.func = async function (obj, args, data, i, level) {
    return Math.atan2(args[0], args[1]);
}
commands.log.func = async function (obj, args, data, i, level) {
    return Math.log(args[1]) / Math.log(args[0]);
}
commands.exponent.func = async function (obj, args, data, i, level) {
    return args[0] ** args[1];
}
commands.array.func = async function (obj, args, data, i, level) {
    return args;
}
commands.at.func = async function (obj, args, data, i, level) {
    canvA.ctx.clearRect(0, 0, canvasWidth, canvasHeight);
    canvA.drawSprite(args[0]);

    let caDat = canvA.ctx.getImageData(args[1] + canvasWidth / 2, args[2] + canvasHeight / 2, 1, 1).data;

    return caDat[3] > 0;
}
commands.clicked.func = async function (obj, args, data, i, level) {
    return mouseClick;
}
commands.clickedHere.func = async function (obj, args, data, i, level) {
    canvA.ctx.clearRect(0, 0, canvasWidth, canvasHeight);
    canvA.drawSprite(args[0]);

    let caDat = canvA.ctx.getImageData(mouseX + canvasWidth / 2, mouseY + canvasHeight / 2, 1, 1).data;

    return mouseClick && caDat[3] > 0;
}
commands.mouse.func = async function (obj, args, data, i, level) {
    return { 'x position': mouseX, 'y position': mouseY };
}
commands.json.func = async function (obj, args, data, i, level) {
    try {
        return JSON.parse(args[0]);
    } catch (err) {
        return false;
    }
}
commands.unjson.func = async function (obj, args, data, i, level) {
    return JSON.stringify(args[0]);
}
commands.clone.func = async function (obj, args, data, i, level) {
    if (sprite.sprites[args[1]]) return false;
    let spr = sprite.sprites[args[0]];
    spr.clones = (spr.clones || 0) + 1;
    sprite.sprites[args[1]] = {
        isClone: true,
        p: new Parser(),
        code: spr.code
    };
    sprite.sprites[args[1]].p.variables = { ...spr.p.variables }
    let id = sprite.sprites[args[1]].p.variables.cloneId = spr.clones;
    sprite.sprites[args[1]].p.variables.me = args[1];

    let datea = sprite.sprites[args[1]].p.parseBrace(spr.code || '');
    sprite.sprites[args[1]].p.parseCode(datea, 0, 1);

    sprite.resort();

    console.log(lastUpdateClone)
    if (lastUpdateClone - (new Date) < -300) {
        lastUpdateClone = +(new Date);
        sprite.updateSprite();
    }
    return false;
}

let lastUpdateClone = +(new Date)

commands.unclone.func = async function (obj, args, data, i, level) {
    delete sprite.sprites[args[0]];
    sprite.resort();

    if (lastUpdateClone - +(new Date) < -300) {
        lastUpdateClone = +(new Date);
        console.log(lastUpdateClone)
        sprite.updateSprite();
    }
    return false;
}


commands.timer.func = async function (obj, args, data, i, level) {
    return ((+new Date) - initTimer) / 1000;
}
