function CanvasManager(sprite, canv) {
    this.elem = canv || document.querySelector('canvas');
    this.ctx = this.elem.getContext('2d');
    this.sprite = sprite;
}

CanvasManager.prototype.drawSprite = function(spr) {
    let sprite = this.sprite.sprites[spr];
    if (!sprite.p) return;

    if (sprite.p.variables["hidden"]) return;
    let img = sprite.p.variables["costume"];
    if (!img) return;

    let size = sprite.p.variables["size"] / 100;

    let x2 = sprite.p.variables["x position"] * 1;
    let y2 = sprite.p.variables["y position"] * 1;

    let x = x2 - (img.width * size / 2) + canvasWidth / 2;
    let y = y2 - (img.height * size / 2) + canvasHeight / 2;

    let ctx = this.ctx;

    ctx.save();
    ctx.translate(canvasWidth / 2 + x2, canvasHeight / 2 + y2);
    if (sprite.p.variables["flipped"]) {
        ctx.scale(-1, 1);
    }
    ctx.rotate(Math.PI / 180 * (sprite.p.variables["rotation"] - 90));
    ctx.translate(-canvasWidth / 2 - x2, -canvasHeight / 2 - y2);

    ctx.drawImage(img, x, y, img.width * size, img.height * size);
    ctx.restore();

    ctx.font = `${sprite.p.variables["font size"] * 1}px ${sprite.p.variables["font family"]}`;
    ctx.fillStyle = sprite.p.variables["fill color"];
    ctx.strokeStyle = sprite.p.variables["stroke color"];
    ctx.lineWidth = sprite.p.variables["stroke size"] * 1;
    ctx.fillText(sprite.p.variables["text"] || '', x, y);
    ctx.strokeText(sprite.p.variables["text"] || '', x, y);
}

CanvasManager.prototype.draw = function() {
    this.ctx.clearRect(0, 0, this.elem.width, this.elem.height);

    for (let spr of this.sprite.spritesI) {
        this.drawSprite(spr, this.ctx);
    }

}

