function sanitize(text) {
    const decoder = document.createElement('div')
    decoder.textContent = text;
    const sanitized = decoder.innerHTML;
    return sanitized;
}

function sleep(time) {
    return new Promise((resolve) => setTimeout(resolve, time));
}

let parser = new Parser();
let sprite = new SpriteManager();
let loader = new FileLoader(sprite);
let canv = new CanvasManager(sprite);
let blocks = new BlockMenu(sprite);
let view = new ViewManager(parser, sprite,blocks);

let thing2;

let canvasWidth = 480;
let canvasHeight = 360;

async function loaderFunc(inDat) {
    let dat = new URL(window.location).searchParams;

    let h, w;

    document.querySelector('#canvas-test1').width = document.querySelector('#canvas-test2').width =
        c.width = canvasWidth = w = dat.get('width') || 480;
    document.querySelector('#canvas-test1').height = document.querySelector('#canvas-test2').height =
        c.height = canvasHeight = h = dat.get('height') || 360;

    if (dat.get('embed')) {
        c.style.width = `calc(min(100vw, ${w / h * 100}vh) - ${w / h * 120}px)`
        c.style.height = `calc(min(100vh, ${h / w * 100}vw) - 120px)`

        document.body.classList.add('embed');
    }
    thing2 = dat.get('data');
    if (!thing2 && !inDat) {
        view.blocks();
        return;
    }
    let thing = inDat || await fetch(thing2);
    if (!inDat) thing = await thing.json();
    sprite.sprites = thing;

    for (let sprite2 in sprite.sprites) {
        if (sprite2.startsWith('__')) delete sprite.sprites[sprite2];
    }

    document.querySelector('.left').value = sprite.sprites[sprite.sel].code;

    sprite.updateSprite();

    if (dat.get('embed')) {
        document.addEventListener('click', function () {
            if (rMode) return;
            rMode = !rMode;
            view.run();
        });
    }

    view.blocks();
}

var c = document.querySelector('canvas');
let rMode;

sprite.updateSprite();

document.querySelector('.left').value = sprite.sprites[sprite.sel].code;

setInterval(function() { canv.draw() }, 1000 / 60);

setInterval(function() { sprite.update() }, 1000);

loaderFunc();

var pressedKeys = {};
window.onkeyup = function (e) { pressedKeys[e.key] = false; }
window.onkeydown = function (e) { pressedKeys[e.key] = true; }

var mouseX = 0;
var mouseY = 0;
var mouseClick = false;
var bounding = c.getBoundingClientRect();

c.ontouchstart = c.onmousedown = function (e) { mouseClick = true; }
c.ontouchend = c.ontouchcancel = c.onmouseup = function (e) { mouseClick = false; }
c.onmousemove = function (e) {
    mouseX = e.clientX - bounding.left - canvasWidth / 2; mouseY = e.clientY - bounding.top - canvasHeight / 2;
}

document.body.onmousemove = function (e) {
    let t = document.querySelector('.tooltip');
    t.className = 'tooltip clicker block-' + commands[blocks.selType].type;
    t.style.top = e.clientY + 'px';
    t.style.left = e.clientX + 'px';
    t.textContent = blocks.selType;
}

for (let sprite2 in sprite.sprites) {
    sprite.parse(sprite2, false);
}

let canvA = new CanvasManager(sprite,document.querySelector('#canvas-test1'));
let canvB = new CanvasManager(sprite,document.querySelector('#canvas-test2'));

let u = new URL(window.location.href);
let p = new URLSearchParams(u.search);

let tokenIn = p.get('token') || window.localStorage.getItem('token');

p.set('token','');
u.search = p;

if (tokenIn && tokenIn.length > 1) {
    window.history.replaceState(null,null,u);
    window.localStorage.setItem('token',tokenIn);
}