function SpriteManager() {
    this.sprites = {
        "Starter": {
            "code":
                `(comment (
        Welcome!
    ))
    
    (set (text (costume)) (image (text (./example.svg))))

    (summon (do (forever (do
        (play (audio (text (./example.mp3))))
    ))))
    
    (summon (do (forever (do
        (set (text (size)) (multiply (get (text (size))) (text (1.001)) ))
    ))))`,
        }
    };
    this.sel = "Starter";
    this.lMenu = document.querySelector('.dat.left');
    this.spriteMenu =  document.querySelector('.sprites');
    this.spritesI = [];
}

SpriteManager.prototype.parse = async function (sprite, runCode = true) {
    let spr = this.sprites[sprite] || {};
    let img = new Image();
    img.src = './example.svg';

    if (spr.p) spr.p.stop = true;

    spr.p = new Parser();

    spr.p.variables = {
        "x position": 0,
        "y position": 0,
        "costume": img,
        "size": 100,
        "rotation": 90,
        "layer": 0,
        "hidden": false,
        "font size": 16,
        "font family": "sans-serif",
        "fill color": "black",
        "stroke size": "0",
        "me": sprite
    };

    spr.clones = 0;
    this.resort();

    let data = spr.p.parseBrace(spr.code || '');

    if (runCode) spr.p.parseCode(data, 0, 1);
}

SpriteManager.prototype.updateSprite = function () {
    this.spriteMenu.innerHTML = '';
    for (let sprite in this.sprites) {
        this.spriteMenu.innerHTML += `<p><a href='#' onclick='view.switch(this.textContent)'>${sanitize(sprite)}</a></p>`
    }
    this.spriteMenu.innerHTML += `<p><input placeholder='New Sprite' onchange='sprite.sprites[this.value] = {}; sprite.updateSprite();'></p>`
}

SpriteManager.prototype.update = function () {
    let sprite2 = this.sprites[this.sel];
    if (!sprite2.p) return;
    let vars = {}; 

    for (let variable in sprite2.p.variables) {
        vars[variable] = sprite2.p.variables[variable];
    }
    if (sprite2.assets) {
        for (let asset in sprite2.assets) {
            vars['(Asset) ' + asset] = sprite2.assets[asset];
        }
    }
    this.lMenu.innerHTML = '';
    for (let vare in vars) {
        let varh = vars[vare];
        if (varh && varh.tagName == "IMG") {
            this.lMenu.innerHTML += `<p><b>${sanitize(vare)}</b>:<br/> <img height='250px' src='${sanitize(varh.src)}'></img></p>`
            continue;
        }
        if (varh && typeof varh != "string") varh = JSON.stringify(varh);
        if (varh && varh.length > 100) {
            varh = varh.substring(0, 97) + "...";
        }
        this.lMenu.innerHTML += `<p><b>${sanitize(vare)}</b>: ${sanitize(varh)}</p>`
    }
}

SpriteManager.prototype.resort = function() {
    this.spritesI = Object.keys(this.sprites).sort((a, b) => (this.sprites[a].p ? this.sprites[a].p.variables['layer'] : 0) - (this.sprites[b].p ? this.sprites[b].p.variables['layer'] : 0));
}
