function ViewManager(parser, sprite, block) {
    this.elem = document.querySelectorAll('.left');
    this.parser = parser;
    this.sprite = sprite;
    this.block = block;
}
ViewManager.prototype.cmdSort = function (a, b) {
    return (commands[a].type + " " + a).localeCompare(commands[b].type + " " + b)
}
ViewManager.prototype.cmdSortList = function () {
    let th = this;
    return Object.keys(commands).sort(function (a, b) { return th.cmdSort(a, b) }).filter(x => x.length > 1);
}


ViewManager.prototype.change = function () {
    for (let elem of this.elem) {
        elem.style = 'display: none';
    }
}

ViewManager.prototype.code = function () {
    this.change();
    document.querySelector('textarea.left').style = '';
}

ViewManager.prototype.dat = function () {
    this.change();
    document.querySelector('.dat.left').style = '';
}

ViewManager.prototype.embed = function () {
    window.open(window.location + '&embed=true');
}

let initTimer = 0;

ViewManager.prototype.run = function () {
    initTimer = (+new Date);
    this.stop();
    this.switch(this.sprite.sel);
    for (let sprite2 in this.sprite.sprites) {
        this.sprite.parse(sprite2);
    }
}

ViewManager.prototype.switch = function (tag) {
    let ta = document.querySelector('.left');
    if (this.sprite.sprites[this.sprite.sel]) this.sprite.sprites[this.sprite.sel].code = ta.value;
    this.sprite.sel = tag;
    ta.value = this.sprite.sprites[this.sprite.sel].code || '';
    this.blocks();
}

ViewManager.prototype.stop = function () {
    for (let el of document.querySelectorAll('audio')) {
        el.pause();
        el.remove();
    }
    for (let sprite2 in this.sprite.sprites) {
        let sprite = this.sprite.sprites[sprite2];
        if (sprite.p) sprite.p.stop = true;
        if (sprite.isClone) delete this.sprite.sprites[sprite2];
    }
    this.sprite.update();
}

ViewManager.prototype.del = function () {
    let prompt = confirm("Are you sure you want to delete this sprite?");
    if (!prompt) return;
    delete this.sprite.sprites[this.sprite.sel];
    this.sprite.updateSprite();
    this.switch(Object.keys(this.sprite)[0]);
}

ViewManager.prototype.blocks = function () {
    if (this.sprite.sprites[this.sprite.sel]) this.sprite.sprites[this.sprite.sel].code = document.querySelector('.left').value;
    this.change();
    let th = document.querySelector('.block.left');

    th.style = '';
    th.innerHTML = '<div class="tooltip" style="position: fixed;"></div> <div class="menu"></div>';

    let cmds = this.cmdSortList();

    let types = [];

    let menu = th.querySelector('.menu');

    for (let command of cmds) {
        let type = commands[command].type;
        if (command == '') continue;
        if (types.indexOf(type) == -1) {
            types.push(type);
            menu.innerHTML += `<a href='#' class='clicker block-${type} typer' onclick='blocks.reselect(this.textContent)'><b>${sanitize(type)}</b></a>`
        }
    }
    menu.innerHTML += `<br/>`

    for (let command of cmds) {
        let type = commands[command].type;
        if (command == '') continue;
        menu.innerHTML += `<a href='#' class='clicker block-${type}' onclick='blocks.selType = "${sanitize(command)}";' style='display: none;'>${sanitize(commands[command].alias) || sanitize(command)}</a>`
    }

    let data = this.parser.parseBrace(this.sprite.sprites[this.sprite.sel].code || '');

    th.appendChild(this.block.renderBlocks(data, 0, 1));
}